Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| JavaTM 2 Platform Std. Ed. v1.3.1
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## java.awt
Class Component

    java.lang.Object
      |
      +--java.awt.Component

All Implemented Interfaces:
  ImageObserver, MenuContainer, Serializable

Direct Known Subclasses:
  Box.Filler, Button, Canvas, Checkbox, Choice, Container, Label, List, Scrollbar, TextComponent

public abstract class Component
extends Object
implements ImageObserver, MenuContainer, Serializable

A component is an object having a graphical representation that can be displayed on the screen and that can interact with the user. Examples of components are the buttons, checkboxes, and scrollbars of a typical graphical user interface.

The `Component` class is the abstract superclass of the nonmenu-related Abstract Window Toolkit components. Class `Component` can also be extended directly to create a lightweight component. A lightweight component is a component that is not associated with a native opaque window.

See Also:
  Serialized Form

Inner Class Summary
`protected class` | `Component.AccessibleAWTComponent` Inner class of Component used to provide default support for accessibility.

Field Summary
`static float` | `BOTTOM_ALIGNMENT` Ease-of-use constant for `getAlignmentY`.
`static float` | `CENTER_ALIGNMENT` Ease-of-use constant for `getAlignmentY` and `getAlignmentX`.
`static float` | `LEFT_ALIGNMENT` Ease-of-use constant for `getAlignmentX`.
`static float` | `RIGHT_ALIGNMENT` Ease-of-use constant for `getAlignmentX`.
`static float` | `TOP_ALIGNMENT` Ease-of-use constant for `getAlignmentY()`.

Fields inherited from interface java.awt.image.ImageObserver
`ABORT, ALLBITS, ERROR, FRAMEBITS, HEIGHT, PROPERTIES, SOMEBITS, WIDTH`

Constructor Summary
`protected` | `Component()` Constructs a new component.

Method Summary
`boolean` | `action(Event evt, Object what)` Deprecated. As of JDK version 1.1, should register this component as ActionListener on component which fires action events.
`void` | `add(PopupMenu popup)` Adds the specified popup menu to the component.
`void` | `addComponentListener(ComponentListener l)` Adds the specified component listener to receive component events from this component.
`void` | `addFocusListener(FocusListener l)` Adds the specified focus listener to receive focus events from this component when this component gains input focus.
`void` | `addHierarchyBoundsListener(HierarchyBoundsListener l)` Adds the specified hierarchy bounds listener to receive hierarchy bounds events from this component when the hierarchy to which this container belongs changes.
`void` | `addHierarchyListener(HierarchyListener l)` Adds the specified hierarchy listener to receive hierarchy changed events from this component when the hierarchy to which this container belongs changes.
`void` | `addInputMethodListener(InputMethodListener l)` Adds the specified input method listener to receive input method events from this component.
`void` | `addKeyListener(KeyListener l)` Adds the specified key listener to receive key events from this component.
`void` | `addMouseListener(MouseListener l)` Adds the specified mouse listener to receive mouse events from this component.
`void` | `addMouseMotionListener(MouseMotionListener l)` Adds the specified mouse motion listener to receive mouse motion events from this component.
`void` | `addNotify()` Makes this Component displayable by connecting it to a native screen resource.
`void` | `addPropertyChangeListener(PropertyChangeListener listener)` Add a PropertyChangeListener to the listener list.
`void` | `addPropertyChangeListener(String propertyName, PropertyChangeListener listener)` Add a PropertyChangeListener for a specific property.
`Rectangle` | `bounds()` Deprecated. As of JDK version 1.1, replaced by `getBounds()`.
`int` | `checkImage(Image image, ImageObserver observer)` Returns the status of the construction of a screen representation of the specified image.
`int` | `checkImage(Image image, int width, int height, ImageObserver observer)` Returns the status of the construction of a screen representation of the specified image.
`protected AWTEvent` | `coalesceEvents(AWTEvent existingEvent, AWTEvent newEvent)` Potentially coalesce an event being posted with an existing event.
`boolean` | `contains(int x, int y)` Checks whether this component "contains" the specified point, where `x` and `y` are defined to be relative to the coordinate system of this component.
`boolean` | `contains(Point p)` Checks whether this component "contains" the specified point, where the point's x and y coordinates are defined to be relative to the coordinate system of this component.
`Image` | `createImage(ImageProducer producer)` Creates an image from the specified image producer.
`Image` | `createImage(int width, int height)` Creates an off-screen drawable image to be used for double buffering.
`void` | `deliverEvent(Event e)` Deprecated. As of JDK version 1.1, replaced by `dispatchEvent(AWTEvent e)`.
`void` | `disable()` Deprecated. As of JDK version 1.1, replaced by `setEnabled(boolean)`.
`protected void` | `disableEvents(long eventsToDisable)` Disables the events defined by the specified event mask parameter from being delivered to this component.
`void` | `dispatchEvent(AWTEvent e)` Dispatches an event to this component or one of its sub components.
`void` | `doLayout()` Prompts the layout manager to lay out this component.
`void` | `enable()` Deprecated. As of JDK version 1.1, replaced by `setEnabled(boolean)`.
`void` | `enable(boolean b)` Deprecated. As of JDK version 1.1, replaced by `setEnabled(boolean)`.
`protected void` | `enableEvents(long eventsToEnable)` Enables the events defined by the specified event mask parameter to be delivered to this component.
`void` | `enableInputMethods(boolean enable)` Enables or disables input method support for this component.
`protected void` | `firePropertyChange(String propertyName, Object oldValue, Object newValue)` Support for reporting bound property changes.
`AccessibleContext` | `getAccessibleContext()` Get the AccessibleContext associated with this Component
`float` | `getAlignmentX()` Returns the alignment along the x axis.
`float` | `getAlignmentY()` Returns the alignment along the y axis.
`Color` | `getBackground()` Gets the background color of this component.
`Rectangle` | `getBounds()` Gets the bounds of this component in the form of a `Rectangle` object.
`Rectangle` | `getBounds(Rectangle rv)` Store the bounds of this component into "return value" rv and return rv.
`ColorModel` | `getColorModel()` Gets the instance of `ColorModel` used to display the component on the output device.
`Component` | `getComponentAt(int x, int y)` Determines if this component or one of its immediate subcomponents contains the (x, y) location, and if so, returns the containing component.
`Component` | `getComponentAt(Point p)` Returns the component or subcomponent that contains the specified point.
`ComponentOrientation` | `getComponentOrientation()` Retrieve the language-sensitive orientation that is to be used to order the elements or text within this component.
`Cursor` | `getCursor()` Gets the cursor set in the component.
`DropTarget` | `getDropTarget()` Get the DropTarget associated with this Component
`Font` | `getFont()` Gets the font of this component.
`FontMetrics` | `getFontMetrics(Font font)` Gets the font metrics for the specified font.
`Color` | `getForeground()` Gets the foreground color of this component.
`Graphics` | `getGraphics()` Creates a graphics context for this component.
`GraphicsConfiguration` | `getGraphicsConfiguration()` Get the `GraphicsConfiguration` associated with this `Component`.
`int` | `getHeight()` Return the current height of this component.
`InputContext` | `getInputContext()` Gets the input context used by this component for handling the communication with input methods when text is entered in this component.
`InputMethodRequests` | `getInputMethodRequests()` Gets the input method request handler which supports requests from input methods for this component.
`EventListener[]` | `getListeners(Class listenerType)` Return an array of all the listeners that were added to the Component with addXXXListener(), where XXX is the name of the `listenerType` argument.
`Locale` | `getLocale()` Gets the locale of this component.
`Point` | `getLocation()` Gets the location of this component in the form of a point specifying the component's top-left corner.
`Point` | `getLocation(Point rv)` Store the x,y origin of this component into "return value" rv and return rv.
`Point` | `getLocationOnScreen()` Gets the location of this component in the form of a point specifying the component's top-left corner in the screen's coordinate space.
`Dimension` | `getMaximumSize()` Gets the maximum size of this component.
`Dimension` | `getMinimumSize()` Gets the mininimum size of this component.
`String` | `getName()` Gets the name of the component.
`Container` | `getParent()` Gets the parent of this component.
`java.awt.peer.ComponentPeer` | `getPeer()` Deprecated. As of JDK version 1.1, programs should not directly manipulate peers. replaced by `boolean isDisplayable()`.
`Dimension` | `getPreferredSize()` Gets the preferred size of this component.
`Dimension` | `getSize()` Returns the size of this component in the form of a `Dimension` object.
`Dimension` | `getSize(Dimension rv)` Store the width/height of this component into "return value" rv and return rv.
`Toolkit` | `getToolkit()` Gets the toolkit of this component.
`Object` | `getTreeLock()` Gets the locking object for AWT component-tree and layout Gets this component's locking object (the object that owns the thread sychronization monitor) for AWT component-tree and layout operations.
`int` | `getWidth()` Return the current width of this component.
`int` | `getX()` Return the current x coordinate of the components origin.
`int` | `getY()` Return the current y coordinate of the components origin.
`boolean` | `gotFocus(Event evt, Object what)` Deprecated. As of JDK version 1.1, replaced by processFocusEvent(FocusEvent).
`boolean` | `handleEvent(Event evt)` Deprecated. As of JDK version 1.1 replaced by processEvent(AWTEvent).
`boolean` | `hasFocus()` Returns true if this Component has the keyboard focus.
`void` | `hide()` Deprecated. As of JDK version 1.1, replaced by `setVisible(boolean)`.
`boolean` | `imageUpdate(Image img, int infoflags, int x, int y, int w, int h)` Repaints the component when the image has changed.
`boolean` | `inside(int x, int y)` Deprecated. As of JDK version 1.1, replaced by contains(int, int).
`void` | `invalidate()` Invalidates this component.
`boolean` | `isDisplayable()` Determines whether this component is displayable.
`boolean` | `isDoubleBuffered()` Returns true if this component is painted to an offscreen image ("buffer") that's copied to the screen later.
`boolean` | `isEnabled()` Determines whether this component is enabled.
`boolean` | `isFocusTraversable()` Returns the value of a flag that indicates whether this component can be traversed using Tab or Shift-Tab keyboard focus traversal.
`boolean` | `isLightweight()` A lightweight component doesn't have a native toolkit peer.
`boolean` | `isOpaque()` Returns true if this component is completely opaque, returns false by default.
`boolean` | `isShowing()` Determines whether this component is showing on screen.
`boolean` | `isValid()` Determines whether this component is valid.
`boolean` | `isVisible()` Determines whether this component should be visible when its parent is visible.
`boolean` | `keyDown(Event evt, int key)` Deprecated. As of JDK version 1.1, replaced by processKeyEvent(KeyEvent).
`boolean` | `keyUp(Event evt, int key)` Deprecated. As of JDK version 1.1, replaced by processKeyEvent(KeyEvent).
`void` | `layout()` Deprecated. As of JDK version 1.1, replaced by `doLayout()`.
`void` | `list()` Prints a listing of this component to the standard system output stream `System.out`.
`void` | `list(PrintStream out)` Prints a listing of this component to the specified output stream.
`void` | `list(PrintStream out, int indent)` Prints out a list, starting at the specified indention, to the specified print stream.
`void` | `list(PrintWriter out)` Prints a listing to the specified print writer.
`void` | `list(PrintWriter out, int indent)` Prints out a list, starting at the specified indention, to the specified print writer.
`Component` | `locate(int x, int y)` Deprecated. As of JDK version 1.1, replaced by getComponentAt(int, int).
`Point` | `location()` Deprecated. As of JDK version 1.1, replaced by `getLocation()`.
`boolean` | `lostFocus(Event evt, Object what)` Deprecated. As of JDK version 1.1, replaced by processFocusEvent(FocusEvent).
`Dimension` | `minimumSize()` Deprecated. As of JDK version 1.1, replaced by `getMinimumSize()`.
`boolean` | `mouseDown(Event evt, int x, int y)` Deprecated. As of JDK version 1.1, replaced by processMouseEvent(MouseEvent).
`boolean` | `mouseDrag(Event evt, int x, int y)` Deprecated. As of JDK version 1.1, replaced by processMouseMotionEvent(MouseEvent).
`boolean` | `mouseEnter(Event evt, int x, int y)` Deprecated. As of JDK version 1.1, replaced by processMouseEvent(MouseEvent).
`boolean` | `mouseExit(Event evt, int x, int y)` Deprecated. As of JDK version 1.1, replaced by processMouseEvent(MouseEvent).
`boolean` | `mouseMove(Event evt, int x, int y)` Deprecated. As of JDK version 1.1, replaced by processMouseMotionEvent(MouseEvent).
`boolean` | `mouseUp(Event evt, int x, int y)` Deprecated. As of JDK version 1.1, replaced by processMouseEvent(MouseEvent).
`void` | `move(int x, int y)` Deprecated. As of JDK version 1.1, replaced by `setLocation(int, int)`.
`void` | `nextFocus()` Deprecated. As of JDK version 1.1, replaced by transferFocus().
`void` | `paint(Graphics g)` Paints this component.
`void` | `paintAll(Graphics g)` Paints this component and all of its subcomponents.
`protected String` | `paramString()` Returns a string representing the state of this component.
`boolean` | `postEvent(Event e)` Deprecated. As of JDK version 1.1, replaced by dispatchEvent(AWTEvent).
`Dimension` | `preferredSize()` Deprecated. As of JDK version 1.1, replaced by `getPreferredSize()`.
`boolean` | `prepareImage(Image image, ImageObserver observer)` Prepares an image for rendering on this component.
`boolean` | `prepareImage(Image image, int width, int height, ImageObserver observer)` Prepares an image for rendering on this component at the specified width and height.
`void` | `print(Graphics g)` Prints this component.
`void` | `printAll(Graphics g)` Prints this component and all of its subcomponents.
`protected void` | `processComponentEvent(ComponentEvent e)` Processes component events occurring on this component by dispatching them to any registered `ComponentListener` objects.
`protected void` | `processEvent(AWTEvent e)` Processes events occurring on this component.
`protected void` | `processFocusEvent(FocusEvent e)` Processes focus events occurring on this component by dispatching them to any registered `FocusListener` objects.
`protected void` | `processHierarchyBoundsEvent(HierarchyEvent e)` Processes hierarchy bounds events occurring on this component by dispatching them to any registered `HierarchyBoundsListener` objects.
`protected void` | `processHierarchyEvent(HierarchyEvent e)` Processes hierarchy events occurring on this component by dispatching them to any registered `HierarchyListener` objects.
`protected void` | `processInputMethodEvent(InputMethodEvent e)` Processes input method events occurring on this component by dispatching them to any registered `InputMethodListener` objects.
`protected void` | `processKeyEvent(KeyEvent e)` Processes key events occurring on this component by dispatching them to any registered `KeyListener` objects.
`protected void` | `processMouseEvent(MouseEvent e)` Processes mouse events occurring on this component by dispatching them to any registered `MouseListener` objects.
`protected void` | `processMouseMotionEvent(MouseEvent e)` Processes mouse motion events occurring on this component by dispatching them to any registered `MouseMotionListener` objects.
`void` | `remove(MenuComponent popup)` Removes the specified popup menu from the component.
`void` | `removeComponentListener(ComponentListener l)` Removes the specified component listener so that it no longer receives component events from this component.
`void` | `removeFocusListener(FocusListener l)` Removes the specified focus listener so that it no longer receives focus events from this component.
`void` | `removeHierarchyBoundsListener(HierarchyBoundsListener l)` Removes the specified hierarchy bounds listener so that it no longer receives hierarchy bounds events from this component.
`void` | `removeHierarchyListener(HierarchyListener l)` Removes the specified hierarchy listener so that it no longer receives hierarchy changed events from this component.
`void` | `removeInputMethodListener(InputMethodListener l)` Removes the specified input method listener so that it no longer receives input method events from this component.
`void` | `removeKeyListener(KeyListener l)` Removes the specified key listener so that it no longer receives key events from this component.
`void` | `removeMouseListener(MouseListener l)` Removes the specified mouse listener so that it no longer receives mouse events from this component.
`void` | `removeMouseMotionListener(MouseMotionListener l)` Removes the specified mouse motion listener so that it no longer receives mouse motion events from this component.
`void` | `removeNotify()` Makes this Component undisplayable by destroying it native screen resource.
`void` | `removePropertyChangeListener(PropertyChangeListener listener)` Remove a PropertyChangeListener from the listener list.
`void` | `removePropertyChangeListener(String propertyName, PropertyChangeListener listener)` Remove a PropertyChangeListener for a specific property.
`void` | `repaint()` Repaints this component.
`void` | `repaint(int x, int y, int width, int height)` Repaints the specified rectangle of this component.
`void` | `repaint(long tm)` Repaints the component.
`void` | `repaint(long tm, int x, int y, int width, int height)` Repaints the specified rectangle of this component within `tm` milliseconds.
`void` | `requestFocus()` Requests that this component get the input focus.
`void` | `reshape(int x, int y, int width, int height)` Deprecated. As of JDK version 1.1, replaced by `setBounds(int, int, int, int)`.
`void` | `resize(Dimension d)` Deprecated. As of JDK version 1.1, replaced by `setSize(Dimension)`.
`void` | `resize(int width, int height)` Deprecated. As of JDK version 1.1, replaced by `setSize(int, int)`.
`void` | `setBackground(Color c)` Sets the background color of this component.
`void` | `setBounds(int x, int y, int width, int height)` Moves and resizes this component.
`void` | `setBounds(Rectangle r)` Moves and resizes this component to conform to the new bounding rectangle `r`.
`void` | `setComponentOrientation(ComponentOrientation o)` Set the language-sensitive orientation that is to be used to order the elements or text within this component.
`void` | `setCursor(Cursor cursor)` Sets the cursor image to the specified cursor.
`void` | `setDropTarget(DropTarget dt)` Associate a DropTarget with this Component.
`void` | `setEnabled(boolean b)` Enables or disables this component, depending on the value of the parameter `b`.
`void` | `setFont(Font f)` Sets the font of this component.
`void` | `setForeground(Color c)` Sets the foreground color of this component.
`void` | `setLocale(Locale l)` Sets the locale of this component.
`void` | `setLocation(int x, int y)` Moves this component to a new location.
`void` | `setLocation(Point p)` Moves this component to a new location.
`void` | `setName(String name)` Sets the name of the component to the specified string.
`void` | `setSize(Dimension d)` Resizes this component so that it has width `d.width` and height `d.height`.
`void` | `setSize(int width, int height)` Resizes this component so that it has width `width` and `height`.
`void` | `setVisible(boolean b)` Shows or hides this component depending on the value of parameter `b`.
`void` | `show()` Deprecated. As of JDK version 1.1, replaced by `setVisible(boolean)`.
`void` | `show(boolean b)` Deprecated. As of JDK version 1.1, replaced by `setVisible(boolean)`.
`Dimension` | `size()` Deprecated. As of JDK version 1.1, replaced by `getSize()`.
`String` | `toString()` Returns a string representation of this component and its values.
`void` | `transferFocus()` Transfers the focus to the next component.
`void` | `update(Graphics g)` Updates this component.
`void` | `validate()` Ensures that this component has a valid layout.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Field Detail

### TOP_ALIGNMENT

    public static final float TOP_ALIGNMENT

  Ease-of-use constant for `getAlignmentY()`. Specifies an alignment to the top of the component.
  See Also:
    `getAlignmentY()`

### CENTER_ALIGNMENT

    public static final float CENTER_ALIGNMENT

  Ease-of-use constant for `getAlignmentY` and `getAlignmentX`. Specifies an alignment to the center of the component
  See Also:
    `getAlignmentX()`, `getAlignmentY()`

### BOTTOM_ALIGNMENT

    public static final float BOTTOM_ALIGNMENT

  Ease-of-use constant for `getAlignmentY`. Specifies an alignment to the bottom of the component.
  See Also:
    `getAlignmentY()`

### LEFT_ALIGNMENT

    public static final float LEFT_ALIGNMENT

  Ease-of-use constant for `getAlignmentX`. Specifies an alignment to the left side of the component.
  See Also:
    `getAlignmentX()`

### RIGHT_ALIGNMENT

    public static final float RIGHT_ALIGNMENT

  Ease-of-use constant for `getAlignmentX`. Specifies an alignment to the right side of the component.
  See Also:
    `getAlignmentX()`

Constructor Detail

### Component

    protected Component()

  Constructs a new component. Class `Component` can be extended directly to create a lightweight component that does not utilize an opaque native window. A lightweight component must be hosted by a native container somewhere higher up in the component tree (for example, by a `Frame` object).

Method Detail

### getName

    public String getName()

  Gets the name of the component.
  Returns:
    This component's name.
  Since:
    JDK1.1
  See Also:
    `setName(java.lang.String)`

### setName

    public void setName(String name)

  Sets the name of the component to the specified string.
  Parameters:
    `name` - The string that is to be this component's name.
  Since:
    JDK1.1
  See Also:
    `getName()`

### getParent

    public Container getParent()

  Gets the parent of this component.
  Returns:
    The parent container of this component.
  Since:
    JDK1.0

### getPeer

    public java.awt.peer.ComponentPeer getPeer()

  Deprecated. As of JDK version 1.1, programs should not directly manipulate peers. replaced by `boolean isDisplayable()`.

### setDropTarget

    public void setDropTarget(DropTarget dt)

  Associate a DropTarget with this Component. The Component will receive drops only if it is enabled.
  Parameters:
    `dt` - The DropTarget
  See Also:
    `isEnabled()`

### getDropTarget

    public DropTarget getDropTarget()

  Get the DropTarget associated with this Component

### getGraphicsConfiguration

    public GraphicsConfiguration getGraphicsConfiguration()

  Get the `GraphicsConfiguration` associated with this `Component`. If the `Component` has not been assigned a specific `GraphicsConfiguration`, the `GraphicsConfiguration` of the `Component` object's top-level container is returned. If the `Component` has been created, but not yet added to a `Container`, this method returns `null`.
  Returns:
    the `GraphicsConfiguration` used by this `Component` or `null`
  Since:
    1.3

### getTreeLock

    public final Object getTreeLock()

  Gets the locking object for AWT component-tree and layout Gets this component's locking object (the object that owns the thread sychronization monitor) for AWT component-tree and layout operations.
  Returns:
    This component's locking object.

### getToolkit

    public Toolkit getToolkit()

  Gets the toolkit of this component. Note that the frame that contains a component controls which toolkit is used by that component. Therefore if the component is moved from one frame to another, the toolkit it uses may change.
  Returns:
    The toolkit of this component.
  Since:
    JDK1.0

### isValid

    public boolean isValid()

  Determines whether this component is valid. A component is valid when it is correctly sized and positioned within its parent container and all its children are also valid. Components are invalidated when they are first shown on the screen.
  Returns:
    `true` if the component is valid; `false` otherwise.
  Since:
    JDK1.0
  See Also:
    `validate()`, `invalidate()`

### isDisplayable

    public boolean isDisplayable()

  Determines whether this component is displayable. A component is displayable when it is connected to a native screen resource.

  A component is made displayable either when it is added to a displayable containment hierarchy or when its containment hierarchy is made displayable. A containment hierarchy is made displayable when its ancestor window is either packed or made visible.

  A component is made undisplayable either when it is removed from a displayable containment hierarchy or when its containment hierarchy is made undisplayable. A containment hierarchy is made undisplayable when its ancestor window is disposed.

  Returns:
    `true` if the component is displayable; `false` otherwise.
  Since:
    1.2
  See Also:
    `Container.add(java.awt.Component)`, `Window.pack()`, `Window.show()`, `Container.remove(java.awt.Component)`, `Window.dispose()`

### isVisible

    public boolean isVisible()

  Determines whether this component should be visible when its parent is visible. Components are initially visible, with the exception of top level components such as `Frame` objects.
  Returns:
    `true` if the component is visible; `false` otherwise.
  Since:
    JDK1.0
  See Also:
    `setVisible(boolean)`

### isShowing

    public boolean isShowing()

  Determines whether this component is showing on screen. This means that the component must be visible, and it must be in a container that is visible and showing.
  Returns:
    `true` if the component is showing; `false` otherwise.
  Since:
    JDK1.0
  See Also:
    `setVisible(boolean)`

### isEnabled

    public boolean isEnabled()

  Determines whether this component is enabled. An enabled component can respond to user input and generate events. Components are enabled initially by default. A component may be enabled or disabled by calling its `setEnabled` method.
  Returns:
    `true` if the component is enabled; `false` otherwise.
  Since:
    JDK1.0
  See Also:
    `setEnabled(boolean)`

### setEnabled

    public void setEnabled(boolean b)

  Enables or disables this component, depending on the value of the parameter `b`. An enabled component can respond to user input and generate events. Components are enabled initially by default.
  Parameters:
    `b` - If `true`, this component is enabled; otherwise this component is disabled.
  Since:
    JDK1.1
  See Also:
    `isEnabled()`

### enable

    public void enable()

  Deprecated. As of JDK version 1.1, replaced by `setEnabled(boolean)`.

### enable

    public void enable(boolean b)

  Deprecated. As of JDK version 1.1, replaced by `setEnabled(boolean)`.

### disable

    public void disable()

  Deprecated. As of JDK version 1.1, replaced by `setEnabled(boolean)`.

### isDoubleBuffered

    public boolean isDoubleBuffered()

  Returns true if this component is painted to an offscreen image ("buffer") that's copied to the screen later. Component subclasses that support double buffering should override this method to return true if double buffering is enabled.
  Returns:
    false by default

### enableInputMethods

    public void enableInputMethods(boolean enable)

  Enables or disables input method support for this component. If input method support is enabled and the component also processes key events, incoming events are offered to the current input method and will only be processed by the component or dispatched to its listeners if the input method does not consume them. By default, input method support is enabled.
  Parameters:
    `enable` - true to enable, false to disable.
  Since:
    1.2
  See Also:
    `processKeyEvent(java.awt.event.KeyEvent)`

### setVisible

    public void setVisible(boolean b)

  Shows or hides this component depending on the value of parameter `b`.
  Parameters:
    `b` - If `true`, shows this component; otherwise, hides this component.
  Since:
    JDK1.1
  See Also:
    `isVisible()`

### show

    public void show()

  Deprecated. As of JDK version 1.1, replaced by `setVisible(boolean)`.

### show

    public void show(boolean b)

  Deprecated. As of JDK version 1.1, replaced by `setVisible(boolean)`.

### hide

    public void hide()

  Deprecated. As of JDK version 1.1, replaced by `setVisible(boolean)`.

### getForeground

    public Color getForeground()

  Gets the foreground color of this component.
  Returns:
    This component's foreground color. If this component does not have a foreground color, the foreground color of its parent is returned.
  Since:
    JDK1.0
  See Also:
    `setForeground(java.awt.Color)`

### setForeground

    public void setForeground(Color c)

  Sets the foreground color of this component.
  Parameters:
    `c` - The color to become this component's foreground color. If this parameter is null then this component will inherit the foreground color of its parent.
  Since:
    JDK1.0
  See Also:
    `getForeground()`

### getBackground

    public Color getBackground()

  Gets the background color of this component.
  Returns:
    This component's background color. If this component does not have a background color, the background color of its parent is returned.
  Since:
    JDK1.0
  See Also:
    `setBackground(java.awt.Color)`

### setBackground

    public void setBackground(Color c)

  Sets the background color of this component.
  Parameters:
    `c` - The color to become this component's color. If this parameter is null then this component will inherit the background color of its parent. background color.
  Since:
    JDK1.0
  See Also:
    `getBackground()`

### getFont

    public Font getFont()

  Gets the font of this component.
  Specified by:
    `getFont` in interface `MenuContainer`
  Returns:
    This component's font. If a font has not been set for this component, the font of its parent is returned.
  Since:
    JDK1.0
  See Also:
    `setFont(java.awt.Font)`

### setFont

    public void setFont(Font f)

  Sets the font of this component.
  Parameters:
    `f` - The font to become this component's font. If this parameter is null then this component will inherit the font of its parent.
  Since:
    JDK1.0
  See Also:
    `getFont()`

### getLocale

    public Locale getLocale()

  Gets the locale of this component.
  Returns:
    This component's locale. If this component does not have a locale, the locale of its parent is returned.
  Throws:
    `IllegalComponentStateException` - If the Component does not have its own locale and has not yet been added to a containment hierarchy such that the locale can be determined from the containing parent.
  Since:
    JDK1.1
  See Also:
    `setLocale(java.util.Locale)`

### setLocale

    public void setLocale(Locale l)

  Sets the locale of this component.
  Parameters:
    `l` - The locale to become this component's locale.
  Since:
    JDK1.1
  See Also:
    `getLocale()`

### getColorModel

    public ColorModel getColorModel()

  Gets the instance of `ColorModel` used to display the component on the output device.
  Returns:
    The color model used by this component.
  Since:
    JDK1.0
  See Also:
    `ColorModel`, `ComponentPeer.getColorModel()`, `Toolkit.getColorModel()`

### getLocation

    public Point getLocation()

  Gets the location of this component in the form of a point specifying the component's top-left corner. The location will be relative to the parent's coordinate space.

  Due to the asynchronous nature of native event handling, this method can return outdated values (for instance, after several calls of `setLocation()` in rapid succession). For this reason, the recommended method of obtaining a Component's position is within `java.awt.event.ComponentListener.componentMoved()`, which is called after the operating system has finished moving the Component.

  Returns:
    An instance of `Point` representing the top-left corner of the component's bounds in the coordinate space of the component's parent.
  Since:
    JDK1.1
  See Also:
    `setLocation(int, int)`, `getLocationOnScreen()`

### getLocationOnScreen

    public Point getLocationOnScreen()

  Gets the location of this component in the form of a point specifying the component's top-left corner in the screen's coordinate space.
  Returns:
    An instance of `Point` representing the top-left corner of the component's bounds in the coordinate space of the screen.
  See Also:
    `setLocation(int, int)`, `getLocation()`

### location

    public Point location()

  Deprecated. As of JDK version 1.1, replaced by `getLocation()`.

### setLocation

    public void setLocation(int x,
                            int y)

  Moves this component to a new location. The top-left corner of the new location is specified by the `x` and `y` parameters in the coordinate space of this component's parent.
  Parameters:
    `x` - The x-coordinate of the new location's top-left corner in the parent's coordinate space.
    `y` - The y-coordinate of the new location's top-left corner in the parent's coordinate space.
  Since:
    JDK1.1
  See Also:
    `getLocation()`, `setBounds(int, int, int, int)`

### move

    public void move(int x,
                     int y)

  Deprecated. As of JDK version 1.1, replaced by `setLocation(int, int)`.

### setLocation

    public void setLocation(Point p)

  Moves this component to a new location. The top-left corner of the new location is specified by point `p`. Point `p` is given in the parent's coordinate space.
  Parameters:
    `p` - The point defining the top-left corner of the new location, given in the coordinate space of this component's parent.
  Since:
    JDK1.1
  See Also:
    `getLocation()`, `setBounds(int, int, int, int)`

### getSize

    public Dimension getSize()

  Returns the size of this component in the form of a `Dimension` object. The `height` field of the `Dimension` object contains this component's height, and the `width` field of the `Dimension` object contains this component's width.
  Returns:
    A `Dimension` object that indicates the size of this component.
  Since:
    JDK1.1
  See Also:
    `setSize(int, int)`

### size

    public Dimension size()

  Deprecated. As of JDK version 1.1, replaced by `getSize()`.

### setSize

    public void setSize(int width,
                        int height)

  Resizes this component so that it has width `width` and `height`.
  Parameters:
    `width` - The new width of this component in pixels.
    `height` - The new height of this component in pixels.
  Since:
    JDK1.1
  See Also:
    `getSize()`, `setBounds(int, int, int, int)`

### resize

    public void resize(int width,
                       int height)

  Deprecated. As of JDK version 1.1, replaced by `setSize(int, int)`.

### setSize

    public void setSize(Dimension d)

  Resizes this component so that it has width `d.width` and height `d.height`.
  Parameters:
    `d` - The dimension specifying the new size of this component.
  Since:
    JDK1.1
  See Also:
    `setSize(int, int)`, `setBounds(int, int, int, int)`

### resize

    public void resize(Dimension d)

  Deprecated. As of JDK version 1.1, replaced by `setSize(Dimension)`.

### getBounds

    public Rectangle getBounds()

  Gets the bounds of this component in the form of a `Rectangle` object. The bounds specify this component's width, height, and location relative to its parent.
  Returns:
    A rectangle indicating this component's bounds.
  See Also:
    `setBounds(int, int, int, int)`, `getLocation()`, `getSize()`

### bounds

    public Rectangle bounds()

  Deprecated. As of JDK version 1.1, replaced by `getBounds()`.

### setBounds

    public void setBounds(int x,
                          int y,
                          int width,
                          int height)

  Moves and resizes this component. The new location of the top-left corner is specified by `x` and `y`, and the new size is specified by `width` and `height`.
  Parameters:
    `x` - The new x-coordinate of this component.
    `y` - The new y-coordinate of this component.
    `width` - The new `width` of this component.
    `height` - The new `height` of this component.
  See Also:
    `getBounds()`, `setLocation(int, int)`, `setLocation(java.awt.Point)`, `setSize(int, int)`, `setSize(java.awt.Dimension)`

### reshape

    public void reshape(int x,
                        int y,
                        int width,
                        int height)

  Deprecated. As of JDK version 1.1, replaced by `setBounds(int, int, int, int)`.

### setBounds

    public void setBounds(Rectangle r)

  Moves and resizes this component to conform to the new bounding rectangle `r`. This component's new position is specified by `r.x` and `r.y`, and its new size is specified by `r.width` and `r.height`
  Parameters:
    `r` - The new bounding rectangle for this component.
  Since:
    JDK1.1
  See Also:
    `getBounds()`, `setLocation(int, int)`, `setLocation(java.awt.Point)`, `setSize(int, int)`, `setSize(java.awt.Dimension)`

### getX

    public int getX()

  Return the current x coordinate of the components origin. This method is preferable to writing component.getBounds().x, or component.getLocation().x because it doesn't cause any heap allocations.
  Returns:
    the current x coordinate of the components origin.
  Since:
    1.2

### getY

    public int getY()

  Return the current y coordinate of the components origin. This method is preferable to writing component.getBounds().y, or component.getLocation().y because it doesn't cause any heap allocations.
  Returns:
    the current y coordinate of the components origin.
  Since:
    1.2

### getWidth

    public int getWidth()

  Return the current width of this component. This method is preferable to writing component.getBounds().width, or component.getSize().width because it doesn't cause any heap allocations.
  Returns:
    the current width of this component.
  Since:
    1.2

### getHeight

    public int getHeight()

  Return the current height of this component. This method is preferable to writing component.getBounds().height, or component.getSize().height because it doesn't cause any heap allocations.
  Returns:
    the current height of this component.
  Since:
    1.2

### getBounds

    public Rectangle getBounds(Rectangle rv)

  Store the bounds of this component into "return value" rv and return rv. If rv is null a new Rectangle is allocated. This version of getBounds() is useful if the caller wants to avoid allocating a new Rectangle object on the heap.
  Parameters:
    `rv` - the return value, modified to the components bounds
  Returns:
    rv

### getSize

    public Dimension getSize(Dimension rv)

  Store the width/height of this component into "return value" rv and return rv. If rv is null a new Dimension object is allocated. This version of getSize() is useful if the caller wants to avoid allocating a new Dimension object on the heap.
  Parameters:
    `rv` - the return value, modified to the components size
  Returns:
    rv

### getLocation

    public Point getLocation(Point rv)

  Store the x,y origin of this component into "return value" rv and return rv. If rv is null a new Point is allocated. This version of getLocation() is useful if the caller wants to avoid allocating a new Point object on the heap.
  Parameters:
    `rv` - the return value, modified to the components location
  Returns:
    rv

### isOpaque

    public boolean isOpaque()

  Returns true if this component is completely opaque, returns false by default.

  An opaque component paints every pixel within its rectangular region. A non-opaque component paints only some of its pixels, allowing the pixels underneath it to "show through". A component that does not fully paint its pixels therefore provides a degree of transparency. Only lightweight components can be transparent.

  Subclasses that guarantee to always completely paint their contents should override this method and return true. All of the "heavyweight" AWT components are opaque.

  Returns:
    true if this component is completely opaque.
  Since:
    1.2
  See Also:
    `isLightweight()`

### isLightweight

    public boolean isLightweight()

  A lightweight component doesn't have a native toolkit peer. Subclasses of Component and Container, other than the ones defined in this package like Button or Scrollbar, are lightweight. All of the Swing components are lightweights. This method will always return `false` if this Component is not displayable because it is impossible to determine the weight of an undisplayable Component.
  Returns:
    true if this component has a lightweight peer; false if it has a native peer or no peer.
  Since:
    1.2
  See Also:
    `isDisplayable()`

### getPreferredSize

    public Dimension getPreferredSize()

  Gets the preferred size of this component.
  Returns:
    A dimension object indicating this component's preferred size.
  See Also:
    `getMinimumSize()`, `LayoutManager`

### preferredSize

    public Dimension preferredSize()

  Deprecated. As of JDK version 1.1, replaced by `getPreferredSize()`.

### getMinimumSize

    public Dimension getMinimumSize()

  Gets the mininimum size of this component.
  Returns:
    A dimension object indicating this component's minimum size.
  See Also:
    `getPreferredSize()`, `java.awtLayoutManager`

### minimumSize

    public Dimension minimumSize()

  Deprecated. As of JDK version 1.1, replaced by `getMinimumSize()`.

### getMaximumSize

    public Dimension getMaximumSize()

  Gets the maximum size of this component.
  Returns:
    A dimension object indicating this component's maximum size.
  See Also:
    `getMinimumSize()`, `getPreferredSize()`, `LayoutManager`

### getAlignmentX

    public float getAlignmentX()

  Returns the alignment along the x axis. This specifies how the component would like to be aligned relative to other components. The value should be a number between 0 and 1 where 0 represents alignment along the origin, 1 is aligned the furthest away from the origin, 0.5 is centered, etc.

### getAlignmentY

    public float getAlignmentY()

  Returns the alignment along the y axis. This specifies how the component would like to be aligned relative to other components. The value should be a number between 0 and 1 where 0 represents alignment along the origin, 1 is aligned the furthest away from the origin, 0.5 is centered, etc.

### doLayout

    public void doLayout()

  Prompts the layout manager to lay out this component. This is usually called when the component (more specifically, container) is validated.
  See Also:
    `validate()`, `LayoutManager`

### layout

    public void layout()

  Deprecated. As of JDK version 1.1, replaced by `doLayout()`.

### validate

    public void validate()

  Ensures that this component has a valid layout. This method is primarily intended to operate on instances of `Container`.
  Since:
    JDK1.0
  See Also:
    `invalidate()`, `doLayout()`, `LayoutManager`, `Container.validate()`

### invalidate

    public void invalidate()

  Invalidates this component. This component and all parents above it are marked as needing to be laid out. This method can be called often, so it needs to execute quickly.
  Since:
    JDK1.0
  See Also:
    `validate()`, `doLayout()`, `LayoutManager`

### getGraphics

    public Graphics getGraphics()

  Creates a graphics context for this component. This method will return `null` if this component is currently not displayable.
  Returns:
    A graphics context for this component, or `null` if it has none.
  Since:
    JDK1.0
  See Also:
    `paint(java.awt.Graphics)`

### getFontMetrics

    public FontMetrics getFontMetrics(Font font)

  Gets the font metrics for the specified font.
  Parameters:
    `font` - The font for which font metrics is to be obtained.
    `font` - the font.
  Returns:
    The font metrics for `font`.
  Since:
    JDK1.0
  See Also:
    `getFont()`, `getPeer()`, `ComponentPeer.getFontMetrics(java.awt.Font)`, `Toolkit.getFontMetrics(java.awt.Font)`

### setCursor

    public void setCursor(Cursor cursor)

  Sets the cursor image to the specified cursor. This cursor image is displayed when the `contains` method for this component returns true for the current cursor location, and this Component is visible, displayable, and enabled. Setting the cursor of a `Container` causes that cursor to be displayed within all of the container's subcomponents, except for those that have a non-null cursor.
  Parameters:
    `cursor` - One of the constants defined by the `Cursor` class. If this parameter is null then this component will inherit the cursor of its parent.
  Since:
    JDK1.1
  See Also:
    `isEnabled()`, `isShowing()`, `getCursor()`, `contains(int, int)`, `Toolkit.createCustomCursor(java.awt.Image, java.awt.Point, java.lang.String)`, `Cursor`

### getCursor

    public Cursor getCursor()

  Gets the cursor set in the component. If the component does not have a cursor set, the cursor of its parent is returned. If no Cursor is set in the entire hierarchy, Cursor.DEFAULT_CURSOR is returned.
  Since:
    JDK1.1
  See Also:
    `setCursor(java.awt.Cursor)`

### paint

    public void paint(Graphics g)

  Paints this component. This method is called when the contents of the component should be painted in response to the component first being shown or damage needing repair. The clip rectangle in the Graphics parameter will be set to the area which needs to be painted. For performance reasons, Components with zero width or height aren't considered to need painting when they are first shown, and also aren't considered to need repair.
  Parameters:
    `g` - The graphics context to use for painting.
  Since:
    JDK1.0
  See Also:
    `update(java.awt.Graphics)`

### update

    public void update(Graphics g)

  Updates this component.

  The AWT calls the `update` method in response to a call to `repaintupdate` or `paint`. You can assume that the background is not cleared.

  The `update`method of `Component` does the following:

  > - Clears this component by filling it with the background color.
  > - Sets the color of the graphics context to be the foreground color of this component.
  > - Calls this component's `paint` method to completely redraw this component.

  The origin of the graphics context, its (`0`, `0`) coordinate point, is the top-left corner of this component. The clipping region of the graphics context is the bounding rectangle of this component.

  Parameters:
    `g` - the specified context to use for updating.
  Since:
    JDK1.0
  See Also:
    `paint(java.awt.Graphics)`, `repaint()`

### paintAll

    public void paintAll(Graphics g)

  Paints this component and all of its subcomponents.

  The origin of the graphics context, its (`0`, `0`) coordinate point, is the top-left corner of this component. The clipping region of the graphics context is the bounding rectangle of this component.

  Parameters:
    `g` - the graphics context to use for painting.
  Since:
    JDK1.0
  See Also:
    `paint(java.awt.Graphics)`

### repaint

    public void repaint()

  Repaints this component.

  This method causes a call to this component's `update` method as soon as possible.

  Since:
    JDK1.0
  See Also:
    `update(java.awt.Graphics)`

### repaint

    public void repaint(long tm)

  Repaints the component. This will result in a call to `update` within tm milliseconds.
  Parameters:
    `tm` - maximum time in milliseconds before update
  Since:
    JDK1.0
  See Also:
    `paint(java.awt.Graphics)`, `update(java.awt.Graphics)`

### repaint

    public void repaint(int x,
                        int y,
                        int width,
                        int height)

  Repaints the specified rectangle of this component.

  This method causes a call to this component's `update` method as soon as possible.

  Parameters:
    `x` - the x coordinate.
    `y` - the y coordinate.
    `width` - the width.
    `height` - the height.
  Since:
    JDK1.0
  See Also:
    `update(java.awt.Graphics)`

### repaint

    public void repaint(long tm,
                        int x,
                        int y,
                        int width,
                        int height)

  Repaints the specified rectangle of this component within `tm` milliseconds.

  This method causes a call to this component's `update` method.

  Parameters:
    `tm` - maximum time in milliseconds before update.
    `x` - the x coordinate.
    `y` - the y coordinate.
    `width` - the width.
    `height` - the height.
  Since:
    JDK1.0
  See Also:
    `update(java.awt.Graphics)`

### print

    public void print(Graphics g)

  Prints this component. Applications should override this method for components that must do special processing before being printed or should be printed differently than they are painted.

  The default implementation of this method calls the `paint` method.

  The origin of the graphics context, its (`0`, `0`) coordinate point, is the top-left corner of this component. The clipping region of the graphics context is the bounding rectangle of this component.

  Parameters:
    `g` - the graphics context to use for printing.
  Since:
    JDK1.0
  See Also:
    `paint(java.awt.Graphics)`

### printAll

    public void printAll(Graphics g)

  Prints this component and all of its subcomponents.

  The origin of the graphics context, its (`0`, `0`) coordinate point, is the top-left corner of this component. The clipping region of the graphics context is the bounding rectangle of this component.

  Parameters:
    `g` - the graphics context to use for printing.
  Since:
    JDK1.0
  See Also:
    `print(java.awt.Graphics)`

### imageUpdate

    public boolean imageUpdate(Image img,
                               int infoflags,
                               int x,
                               int y,
                               int w,
                               int h)

  Repaints the component when the image has changed. This `imageUpdate` method of an `ImageObserver` is called when more information about an image which had been previously requested using an asynchronous routine such as the `drawImage` method of `Graphics` becomes available. See the definition of `imageUpdate` for more information on this method and its arguments.

  The `imageUpdate` method of `Component` incrementally draws an image on the component as more of the bits of the image are available.

  If the system property `awt.image.incrementalDraw` is missing or has the value `true`, the image is incrementally drawn, If the system property has any other value, then the image is not drawn until it has been completely loaded.

  Also, if incremental drawing is in effect, the value of the system property `awt.image.redrawrate` is interpreted as an integer to give the maximum redraw rate, in milliseconds. If the system property is missing or cannot be interpreted as an integer, the redraw rate is once every 100ms.

  The interpretation of the `x`, `y`, `width`, and `height` arguments depends on the value of the `infoflags` argument.

  Specified by:
    `imageUpdate` in interface `ImageObserver`
  Parameters:
    `img` - the image being observed.
    `infoflags` - see `imageUpdate` for more information.
    `x` - the x coordinate.
    `y` - the y coordinate.
    `w` - the width.
    `h` - the height.
  Returns:
    `false` if the infoflags indicate that the image is completely loaded; `true` otherwise.
  Since:
    JDK1.0
  See Also:
    `ImageObserver`, `Graphics.drawImage(java.awt.Image, int, int, java.awt.Color, java.awt.image.ImageObserver)`, `Graphics.drawImage(java.awt.Image, int, int, java.awt.image.ImageObserver)`, `Graphics.drawImage(java.awt.Image, int, int, int, int, java.awt.Color, java.awt.image.ImageObserver)`, `Graphics.drawImage(java.awt.Image, int, int, int, int, java.awt.image.ImageObserver)`, `ImageObserver.imageUpdate(java.awt.Image, int, int, int, int, int)`

### createImage

    public Image createImage(ImageProducer producer)

  Creates an image from the specified image producer.
  Parameters:
    `producer` - the image producer
  Returns:
    the image produced.
  Since:
    JDK1.0

### createImage

    public Image createImage(int width,
                             int height)

  Creates an off-screen drawable image to be used for double buffering.
  Parameters:
    `width` - the specified width.
    `height` - the specified height.
  Returns:
    an off-screen drawable image, which can be used for double buffering.
  Since:
    JDK1.0

### prepareImage

    public boolean prepareImage(Image image,
                                ImageObserver observer)

  Prepares an image for rendering on this component. The image data is downloaded asynchronously in another thread and the appropriate screen representation of the image is generated.
  Parameters:
    `image` - the `Image` for which to prepare a screen representation.
    `observer` - the `ImageObserver` object to be notified as the image is being prepared.
  Returns:
    `true` if the image has already been fully prepared; `false` otherwise.
  Since:
    JDK1.0

### prepareImage

    public boolean prepareImage(Image image,
                                int width,
                                int height,
                                ImageObserver observer)

  Prepares an image for rendering on this component at the specified width and height.

  The image data is downloaded asynchronously in another thread, and an appropriately scaled screen representation of the image is generated.

  Parameters:
    `image` - the instance of `Image` for which to prepare a screen representation.
    `width` - the width of the desired screen representation.
    `height` - the height of the desired screen representation.
    `observer` - the `ImageObserver` object to be notified as the image is being prepared.
  Returns:
    `true` if the image has already been fully prepared; `false` otherwise.
  Since:
    JDK1.0
  See Also:
    `ImageObserver`

### checkImage

    public int checkImage(Image image,
                          ImageObserver observer)

  Returns the status of the construction of a screen representation of the specified image.

  This method does not cause the image to begin loading. An application must use the `prepareImage` method to force the loading of an image.

  Information on the flags returned by this method can be found with the discussion of the `ImageObserver` interface.

  Parameters:
    `image` - the `Image` object whose status is being checked.
    `observer` - the `ImageObserver` object to be notified as the image is being prepared.
  Returns:
    the bitwise inclusive OR of `ImageObserver` flags indicating what information about the image is currently available.
  Since:
    JDK1.0
  See Also:
    `prepareImage(java.awt.Image, int, int, java.awt.image.ImageObserver)`, `Toolkit.checkImage(java.awt.Image, int, int, java.awt.image.ImageObserver)`, `ImageObserver`

### checkImage

    public int checkImage(Image image,
                          int width,
                          int height,
                          ImageObserver observer)

  Returns the status of the construction of a screen representation of the specified image.

  This method does not cause the image to begin loading. An application must use the `prepareImage` method to force the loading of an image.

  The `checkImage` method of `Component` calls its peer's `checkImage` method to calculate the flags. If this component does not yet have a peer, the component's toolkit's `checkImage` method is called instead.

  Information on the flags returned by this method can be found with the discussion of the `ImageObserver` interface.

  Parameters:
    `image` - the `Image` object whose status is being checked.
    `width` - the width of the scaled version whose status is to be checked.
    `height` - the height of the scaled version whose status is to be checked.
    `observer` - the `ImageObserver` object to be notified as the image is being prepared.
  Returns:
    the bitwise inclusive OR of `ImageObserver` flags indicating what information about the image is currently available.
  Since:
    JDK1.0
  See Also:
    `prepareImage(java.awt.Image, int, int, java.awt.image.ImageObserver)`, `Toolkit.checkImage(java.awt.Image, int, int, java.awt.image.ImageObserver)`, `ImageObserver`

### contains

    public boolean contains(int x,
                            int y)

  Checks whether this component "contains" the specified point, where `x` and `y` are defined to be relative to the coordinate system of this component.
  Parameters:
    `x` - the x coordinate of the point.
    `y` - the y coordinate of the point.
  Since:
    JDK1.1
  See Also:
    `getComponentAt(int, int)`

### inside

    public boolean inside(int x,
                          int y)

  Deprecated. As of JDK version 1.1, replaced by contains(int, int).

### contains

    public boolean contains(Point p)

  Checks whether this component "contains" the specified point, where the point's x and y coordinates are defined to be relative to the coordinate system of this component.
  Parameters:
    `p` - the point.
  Since:
    JDK1.1
  See Also:
    `getComponentAt(java.awt.Point)`

### getComponentAt

    public Component getComponentAt(int x,
                                    int y)

  Determines if this component or one of its immediate subcomponents contains the (x, y) location, and if so, returns the containing component. This method only looks one level deep. If the point (x, y) is inside a subcomponent that itself has subcomponents, it does not go looking down the subcomponent tree.

  The `locate` method of `Component` simply returns the component itself if the (x, y) coordinate location is inside its bounding box, and `null` otherwise.

  Parameters:
    `x` - the x coordinate.
    `y` - the y coordinate.
  Returns:
    the component or subcomponent that contains the (x, y) location; `null` if the location is outside this component.
  Since:
    JDK1.0
  See Also:
    `contains(int, int)`

### locate

    public Component locate(int x,
                            int y)

  Deprecated. As of JDK version 1.1, replaced by getComponentAt(int, int).

### getComponentAt

    public Component getComponentAt(Point p)

  Returns the component or subcomponent that contains the specified point.
  Parameters:
    `p` - the point.
  Since:
    JDK1.1
  See Also:
    `contains(int, int)`

### deliverEvent

    public void deliverEvent(Event e)

  Deprecated. As of JDK version 1.1, replaced by `dispatchEvent(AWTEvent e)`.

### dispatchEvent

    public final void dispatchEvent(AWTEvent e)

  Dispatches an event to this component or one of its sub components. Calls processEvent() before returning for 1.1-style events which have been enabled for the Component.
  Parameters:
    `e` - the event

### postEvent

    public boolean postEvent(Event e)

  Deprecated. As of JDK version 1.1, replaced by dispatchEvent(AWTEvent).

  Specified by:
    `postEvent` in interface `MenuContainer`

### addComponentListener

    public void addComponentListener(ComponentListener l)

  Adds the specified component listener to receive component events from this component. If l is null, no exception is thrown and no action is performed.
  Parameters:
    `l` - the component listener.
  Since:
    JDK1.1
  See Also:
    `ComponentEvent`, `ComponentListener`, `removeComponentListener(java.awt.event.ComponentListener)`

### removeComponentListener

    public void removeComponentListener(ComponentListener l)

  Removes the specified component listener so that it no longer receives component events from this component. This method performs no function, nor does it throw an exception, if the listener specified by the argument was not previously added to this component. If l is null, no exception is thrown and no action is performed.
  Parameters:
    `l` - the component listener.
  Since:
    JDK1.1
  See Also:
    `ComponentEvent`, `ComponentListener`, `addComponentListener(java.awt.event.ComponentListener)`

### addFocusListener

    public void addFocusListener(FocusListener l)

  Adds the specified focus listener to receive focus events from this component when this component gains input focus. If l is null, no exception is thrown and no action is performed.
  Parameters:
    `l` - the focus listener.
  Since:
    JDK1.1
  See Also:
    `FocusEvent`, `FocusListener`, `removeFocusListener(java.awt.event.FocusListener)`

### removeFocusListener

    public void removeFocusListener(FocusListener l)

  Removes the specified focus listener so that it no longer receives focus events from this component. This method performs no function, nor does it throw an exception, if the listener specified by the argument was not previously added to this component. If l is null, no exception is thrown and no action is performed.
  Parameters:
    `l` - the focus listener.
  Since:
    JDK1.1
  See Also:
    `FocusEvent`, `FocusListener`, `addFocusListener(java.awt.event.FocusListener)`

### addHierarchyListener

    public void addHierarchyListener(HierarchyListener l)

  Adds the specified hierarchy listener to receive hierarchy changed events from this component when the hierarchy to which this container belongs changes. If l is null, no exception is thrown and no action is performed.
  Parameters:
    `l` - the hierarchy listener.
  Since:
    1.3
  See Also:
    `HierarchyEvent`, `HierarchyListener`, `removeHierarchyListener(java.awt.event.HierarchyListener)`

### removeHierarchyListener

    public void removeHierarchyListener(HierarchyListener l)

  Removes the specified hierarchy listener so that it no longer receives hierarchy changed events from this component. This method performs no function, nor does it throw an exception, if the listener specified by the argument was not previously added to this component. If l is null, no exception is thrown and no action is performed.
  Parameters:
    `l` - the hierarchy listener.
  Since:
    1.3
  See Also:
    `HierarchyEvent`, `HierarchyListener`, `addHierarchyListener(java.awt.event.HierarchyListener)`

### addHierarchyBoundsListener

    public void addHierarchyBoundsListener(HierarchyBoundsListener l)

  Adds the specified hierarchy bounds listener to receive hierarchy bounds events from this component when the hierarchy to which this container belongs changes. If l is null, no exception is thrown and no action is performed.
  Parameters:
    `l` - the hierarchy bounds listener.
  Since:
    1.3
  See Also:
    `HierarchyEvent`, `HierarchyBoundsListener`, `removeHierarchyBoundsListener(java.awt.event.HierarchyBoundsListener)`

### removeHierarchyBoundsListener

    public void removeHierarchyBoundsListener(HierarchyBoundsListener l)

  Removes the specified hierarchy bounds listener so that it no longer receives hierarchy bounds events from this component. This method performs no function, nor does it throw an exception, if the listener specified by the argument was not previously added to this component. If l is null, no exception is thrown and no action is performed.
  Parameters:
    `l` - the hierarchy bounds listener.
  Since:
    1.3
  See Also:
    `HierarchyEvent`, `HierarchyBoundsListener`, `addHierarchyBoundsListener(java.awt.event.HierarchyBoundsListener)`

### addKeyListener

    public void addKeyListener(KeyListener l)

  Adds the specified key listener to receive key events from this component. If l is null, no exception is thrown and no action is performed.
  Parameters:
    `l` - the key listener.
  Since:
    JDK1.1
  See Also:
    `KeyEvent`, `KeyListener`, `removeKeyListener(java.awt.event.KeyListener)`

### removeKeyListener

    public void removeKeyListener(KeyListener l)

  Removes the specified key listener so that it no longer receives key events from this component. This method performs no function, nor does it throw an exception, if the listener specified by the argument was not previously added to this component. If l is null, no exception is thrown and no action is performed.
  Parameters:
    `l` - the key listener.
  Since:
    JDK1.1
  See Also:
    `KeyEvent`, `KeyListener`, `addKeyListener(java.awt.event.KeyListener)`

### addMouseListener

    public void addMouseListener(MouseListener l)

  Adds the specified mouse listener to receive mouse events from this component. If l is null, no exception is thrown and no action is performed.
  Parameters:
    `l` - the mouse listener.
  Since:
    JDK1.1
  See Also:
    `MouseEvent`, `MouseListener`, `removeMouseListener(java.awt.event.MouseListener)`

### removeMouseListener

    public void removeMouseListener(MouseListener l)

  Removes the specified mouse listener so that it no longer receives mouse events from this component. This method performs no function, nor does it throw an exception, if the listener specified by the argument was not previously added to this component. If l is null, no exception is thrown and no action is performed.
  Parameters:
    `l` - the mouse listener.
  Since:
    JDK1.1
  See Also:
    `MouseEvent`, `MouseListener`, `addMouseListener(java.awt.event.MouseListener)`

### addMouseMotionListener

    public void addMouseMotionListener(MouseMotionListener l)

  Adds the specified mouse motion listener to receive mouse motion events from this component. If l is null, no exception is thrown and no action is performed.
  Parameters:
    `l` - the mouse motion listener.
  Since:
    JDK1.1
  See Also:
    `java.awt.event.MouseMotionEvent`, `MouseMotionListener`, `removeMouseMotionListener(java.awt.event.MouseMotionListener)`

### removeMouseMotionListener

    public void removeMouseMotionListener(MouseMotionListener l)

  Removes the specified mouse motion listener so that it no longer receives mouse motion events from this component. This method performs no function, nor does it throw an exception, if the listener specified by the argument was not previously added to this component. If l is null, no exception is thrown and no action is performed.
  Parameters:
    `l` - the mouse motion listener.
  Since:
    JDK1.1
  See Also:
    `java.awt.event.MouseMotionEvent`, `MouseMotionListener`, `addMouseMotionListener(java.awt.event.MouseMotionListener)`

### addInputMethodListener

    public void addInputMethodListener(InputMethodListener l)

  Adds the specified input method listener to receive input method events from this component. A component will only receive input method events from input methods if it also overrides getInputMethodRequests to return an InputMethodRequests instance. If l is null, no exception is thrown and no action is performed.
  Parameters:
    `l` - the input method listener.
  Since:
    1.2
  See Also:
    `InputMethodEvent`, `InputMethodListener`, `removeInputMethodListener(java.awt.event.InputMethodListener)`, `getInputMethodRequests()`

### removeInputMethodListener

    public void removeInputMethodListener(InputMethodListener l)

  Removes the specified input method listener so that it no longer receives input method events from this component. This method performs no function, nor does it throw an exception, if the listener specified by the argument was not previously added to this component. If l is null, no exception is thrown and no action is performed.
  Parameters:
    `l` - the input method listener.
  Since:
    1.2
  See Also:
    `InputMethodEvent`, `InputMethodListener`, `addInputMethodListener(java.awt.event.InputMethodListener)`

### getListeners

    public EventListener[] getListeners(Class listenerType)

  Return an array of all the listeners that were added to the Component with addXXXListener(), where XXX is the name of the `listenerType` argument. For example, to get all of the MouseListeners for the given Component `c`, one would write:

       MouseListener[] mls = (MouseListener[])(c.getListeners(MouseListener.class))

  If no such listener list exists, then an empty array is returned.
  Parameters:
    `listenerType` - Type of listeners requested. This parameter must be a `java.util.EventListener` or subclass.
  Throws:
    ``ClassCastException`` - if the `listenerType` parameter is not a `java.util.EventListener` or subclass.
  Since:
    1.3

### getInputMethodRequests

    public InputMethodRequests getInputMethodRequests()

  Gets the input method request handler which supports requests from input methods for this component. A component that supports on-the-spot text input must override this method to return an InputMethodRequests instance. At the same time, it also has to handle input method events.
  Returns:
    the input method request handler for this component, null by default.
  Since:
    1.2
  See Also:
    `addInputMethodListener(java.awt.event.InputMethodListener)`

### getInputContext

    public InputContext getInputContext()

  Gets the input context used by this component for handling the communication with input methods when text is entered in this component. By default, the input context used for the parent component is returned. Components may override this to return a private input context.
  Returns:
    The input context used by this component. Null if no context can be determined.
  Since:
    1.2

### enableEvents

    protected final void enableEvents(long eventsToEnable)

  Enables the events defined by the specified event mask parameter to be delivered to this component.

  Event types are automatically enabled when a listener for that event type is added to the component.

  This method only needs to be invoked by subclasses of `Component` which desire to have the specified event types delivered to `processEvent` regardless of whether or not a listener is registered.

  Parameters:
    `eventsToEnable` - the event mask defining the event types.
  Since:
    JDK1.1
  See Also:
    `processEvent(java.awt.AWTEvent)`, `disableEvents(long)`

### disableEvents

    protected final void disableEvents(long eventsToDisable)

  Disables the events defined by the specified event mask parameter from being delivered to this component.
  Parameters:
    `eventsToDisable` - the event mask defining the event types
  Since:
    JDK1.1
  See Also:
    `enableEvents(long)`

### coalesceEvents

    protected AWTEvent coalesceEvents(AWTEvent existingEvent,
                                      AWTEvent newEvent)

  Potentially coalesce an event being posted with an existing event. This method is called by EventQueue.postEvent if an event with the same ID as the event to be posted is found in the queue (both events must have this component as their source). This method either returns a coalesced event which replaces the existing event (and the new event is then discarded), or null to indicate that no combining should be done (add the second event to the end of the queue). Either event parameter may be modified and returned, as the other one is discarded unless null is returned.

  This implementation of coalesceEvents coalesces two event types: mouse move (and drag) events, and paint (and update) events. For mouse move events the last event is always returned, causing intermediate moves to be discarded. For paint events, the new event is coalesced into a complex RepaintArea in the peer. The new Event is always returned.

  Parameters:
    `existingEvent` - the event already on the EventQueue.
    `newEvent` - the event being posted to the EventQueue.
  Returns:
    a coalesced event, or null indicating that no coalescing was done.

### processEvent

    protected void processEvent(AWTEvent e)

  Processes events occurring on this component. By default this method calls the appropriate `process<event type>Event` method for the given class of event.
  Parameters:
    `e` - the event.
  Since:
    JDK1.1
  See Also:
    `processComponentEvent(java.awt.event.ComponentEvent)`, `processFocusEvent(java.awt.event.FocusEvent)`, `processKeyEvent(java.awt.event.KeyEvent)`, `processMouseEvent(java.awt.event.MouseEvent)`, `processMouseMotionEvent(java.awt.event.MouseEvent)`, `processInputMethodEvent(java.awt.event.InputMethodEvent)`, `processHierarchyEvent(java.awt.event.HierarchyEvent)`

### processComponentEvent

    protected void processComponentEvent(ComponentEvent e)

  Processes component events occurring on this component by dispatching them to any registered `ComponentListener` objects.

  This method is not called unless component events are enabled for this component. Component events are enabled when one of the following occurs:

  - A `ComponentListener` object is registered via `addComponentListener`.
  - Component events are enabled via `enableEvents`.
  Parameters:
    `e` - the component event.
  Since:
    JDK1.1
  See Also:
    `ComponentEvent`, `ComponentListener`, `addComponentListener(java.awt.event.ComponentListener)`, `enableEvents(long)`

### processFocusEvent

    protected void processFocusEvent(FocusEvent e)

  Processes focus events occurring on this component by dispatching them to any registered `FocusListener` objects.

  This method is not called unless focus events are enabled for this component. Focus events are enabled when one of the following occurs:

  - A `FocusListener` object is registered via `addFocusListener`.
  - Focus events are enabled via `enableEvents`.
  Parameters:
    `e` - the focus event.
  Since:
    JDK1.1
  See Also:
    `FocusEvent`, `FocusListener`, `addFocusListener(java.awt.event.FocusListener)`, `enableEvents(long)`

### processKeyEvent

    protected void processKeyEvent(KeyEvent e)

  Processes key events occurring on this component by dispatching them to any registered `KeyListener` objects.

  This method is not called unless key events are enabled for this component. Key events are enabled when one of the following occurs:

  - A `KeyListener` object is registered via `addKeyListener`.
  - Key events are enabled via `enableEvents`.
  Parameters:
    `e` - the key event.
  Since:
    JDK1.1
  See Also:
    `KeyEvent`, `KeyListener`, `addKeyListener(java.awt.event.KeyListener)`, `enableEvents(long)`

### processMouseEvent

    protected void processMouseEvent(MouseEvent e)

  Processes mouse events occurring on this component by dispatching them to any registered `MouseListener` objects.

  This method is not called unless mouse events are enabled for this component. Mouse events are enabled when one of the following occurs:

  - A `MouseListener` object is registered via `addMouseListener`.
  - Mouse events are enabled via `enableEvents`.
  Parameters:
    `e` - the mouse event.
  Since:
    JDK1.1
  See Also:
    `MouseEvent`, `MouseListener`, `addMouseListener(java.awt.event.MouseListener)`, `enableEvents(long)`

### processMouseMotionEvent

    protected void processMouseMotionEvent(MouseEvent e)

  Processes mouse motion events occurring on this component by dispatching them to any registered `MouseMotionListener` objects.

  This method is not called unless mouse motion events are enabled for this component. Mouse motion events are enabled when one of the following occurs:

  - A `MouseMotionListener` object is registered via `addMouseMotionListener`.
  - Mouse motion events are enabled via `enableEvents`.
  Parameters:
    `e` - the mouse motion event.
  Since:
    JDK1.1
  See Also:
    `java.awt.event.MouseMotionEvent`, `MouseMotionListener`, `addMouseMotionListener(java.awt.event.MouseMotionListener)`, `enableEvents(long)`

### processInputMethodEvent

    protected void processInputMethodEvent(InputMethodEvent e)

  Processes input method events occurring on this component by dispatching them to any registered `InputMethodListener` objects.

  This method is not called unless input method events are enabled for this component. Input method events are enabled when one of the following occurs:

  - An `InputMethodListener` object is registered via `addInputMethodListener`.
  - Input method events are enabled via `enableEvents`.
  Parameters:
    `e` - the input method event
  Since:
    1.2
  See Also:
    `InputMethodEvent`, `InputMethodListener`, `addInputMethodListener(java.awt.event.InputMethodListener)`, `enableEvents(long)`

### processHierarchyEvent

    protected void processHierarchyEvent(HierarchyEvent e)

  Processes hierarchy events occurring on this component by dispatching them to any registered `HierarchyListener` objects.

  This method is not called unless hierarchy events are enabled for this component. Hierarchy events are enabled when one of the following occurs:

  - An `HierarchyListener` object is registered via `addHierarchyListener`.
  - Hierarchy events are enabled via `enableEvents`.
  Parameters:
    `e` - the hierarchy event
  Since:
    1.3
  See Also:
    `HierarchyEvent`, `HierarchyListener`, `addHierarchyListener(java.awt.event.HierarchyListener)`, `enableEvents(long)`

### processHierarchyBoundsEvent

    protected void processHierarchyBoundsEvent(HierarchyEvent e)

  Processes hierarchy bounds events occurring on this component by dispatching them to any registered `HierarchyBoundsListener` objects.

  This method is not called unless hierarchy bounds events are enabled for this component. Hierarchy bounds events are enabled when one of the following occurs:

  - An `HierarchyBoundsListener` object is registered via `addHierarchyBoundsListener`.
  - Hierarchy bounds events are enabled via `enableEvents`.
  Parameters:
    `e` - the hierarchy event
  Since:
    1.3
  See Also:
    `HierarchyEvent`, `HierarchyBoundsListener`, `addHierarchyBoundsListener(java.awt.event.HierarchyBoundsListener)`, `enableEvents(long)`

### handleEvent

    public boolean handleEvent(Event evt)

  Deprecated. As of JDK version 1.1 replaced by processEvent(AWTEvent).

### mouseDown

    public boolean mouseDown(Event evt,
                             int x,
                             int y)

  Deprecated. As of JDK version 1.1, replaced by processMouseEvent(MouseEvent).

### mouseDrag

    public boolean mouseDrag(Event evt,
                             int x,
                             int y)

  Deprecated. As of JDK version 1.1, replaced by processMouseMotionEvent(MouseEvent).

### mouseUp

    public boolean mouseUp(Event evt,
                           int x,
                           int y)

  Deprecated. As of JDK version 1.1, replaced by processMouseEvent(MouseEvent).

### mouseMove

    public boolean mouseMove(Event evt,
                             int x,
                             int y)

  Deprecated. As of JDK version 1.1, replaced by processMouseMotionEvent(MouseEvent).

### mouseEnter

    public boolean mouseEnter(Event evt,
                              int x,
                              int y)

  Deprecated. As of JDK version 1.1, replaced by processMouseEvent(MouseEvent).

### mouseExit

    public boolean mouseExit(Event evt,
                             int x,
                             int y)

  Deprecated. As of JDK version 1.1, replaced by processMouseEvent(MouseEvent).

### keyDown

    public boolean keyDown(Event evt,
                           int key)

  Deprecated. As of JDK version 1.1, replaced by processKeyEvent(KeyEvent).

### keyUp

    public boolean keyUp(Event evt,
                         int key)

  Deprecated. As of JDK version 1.1, replaced by processKeyEvent(KeyEvent).

### action

    public boolean action(Event evt,
                          Object what)

  Deprecated. As of JDK version 1.1, should register this component as ActionListener on component which fires action events.

### addNotify

    public void addNotify()

  Makes this Component displayable by connecting it to a native screen resource. This method is called internally by the toolkit and should not be called directly by programs.
  Since:
    JDK1.0
  See Also:
    `isDisplayable()`, `removeNotify()`

### removeNotify

    public void removeNotify()

  Makes this Component undisplayable by destroying it native screen resource. This method is called by the toolkit internally and should not be called directly by programs.
  Since:
    JDK1.0
  See Also:
    `isDisplayable()`, `addNotify()`

### gotFocus

    public boolean gotFocus(Event evt,
                            Object what)

  Deprecated. As of JDK version 1.1, replaced by processFocusEvent(FocusEvent).

### lostFocus

    public boolean lostFocus(Event evt,
                             Object what)

  Deprecated. As of JDK version 1.1, replaced by processFocusEvent(FocusEvent).

### isFocusTraversable

    public boolean isFocusTraversable()

  Returns the value of a flag that indicates whether this component can be traversed using Tab or Shift-Tab keyboard focus traversal. If this method returns "false", this component may still request the keyboard focus using `requestFocus()`, but it will not automatically be assigned focus during tab traversal.
  Returns:
    `true` if this component is focus-traverable; `false` otherwise.
  Since:
    JDK1.1

### requestFocus

    public void requestFocus()

  Requests that this component get the input focus. The component must be visible on the screen for this request to be granted
  Since:
    JDK1.0
  See Also:
    `FocusEvent`, `addFocusListener(java.awt.event.FocusListener)`, `processFocusEvent(java.awt.event.FocusEvent)`, `isFocusTraversable()`

### transferFocus

    public void transferFocus()

  Transfers the focus to the next component.
  Since:
    JDK1.1s
  See Also:
    `requestFocus()`

### nextFocus

    public void nextFocus()

  Deprecated. As of JDK version 1.1, replaced by transferFocus().

### hasFocus

    public boolean hasFocus()

  Returns true if this Component has the keyboard focus.
  Returns:
    true if this Component has the keyboard focus.
  Since:
    1.2

### add

    public void add(PopupMenu popup)

  Adds the specified popup menu to the component.
  Parameters:
    `popup` - the popup menu to be added to the component.
  Since:
    JDK1.1
  See Also:
    `remove(java.awt.MenuComponent)`

### remove

    public void remove(MenuComponent popup)

  Removes the specified popup menu from the component.
  Specified by:
    `remove` in interface `MenuContainer`
  Parameters:
    `popup` - the popup menu to be removed.
  Since:
    JDK1.1
  See Also:
    `add(java.awt.PopupMenu)`

### paramString

    protected String paramString()

  Returns a string representing the state of this component. This method is intended to be used only for debugging purposes, and the content and format of the returned string may vary between implementations. The returned string may be empty but may not be `null`.
  Returns:
    a string representation of this component's state.
  Since:
    JDK1.0

### toString

    public String toString()

  Returns a string representation of this component and its values.
  Overrides:
    `toString` in class `Object`
  Returns:
    a string representation of this component.
  Since:
    JDK1.0

### list

    public void list()

  Prints a listing of this component to the standard system output stream `System.out`.
  Since:
    JDK1.0
  See Also:
    `System.out`

### list

    public void list(PrintStream out)

  Prints a listing of this component to the specified output stream.
  Parameters:
    `out` - a print stream.
  Since:
    JDK1.0

### list

    public void list(PrintStream out,
                     int indent)

  Prints out a list, starting at the specified indention, to the specified print stream.
  Parameters:
    `out` - a print stream.
    `indent` - number of spaces to indent.
  Since:
    JDK1.0
  See Also:
    `PrintStream.println(java.lang.Object)`

### list

    public void list(PrintWriter out)

  Prints a listing to the specified print writer.
  Parameters:
    `out` - The print writer to print to.
  Since:
    JDK1.1

### list

    public void list(PrintWriter out,
                     int indent)

  Prints out a list, starting at the specified indention, to the specified print writer.
  Parameters:
    `out` - The print writer to print to.
    `indent` - The number of spaces to indent.
  Since:
    JDK1.1
  See Also:
    `PrintStream.println(java.lang.Object)`

### addPropertyChangeListener

    public void addPropertyChangeListener(PropertyChangeListener listener)

  Add a PropertyChangeListener to the listener list. The listener is registered for all properties.

  A PropertyChangeEvent will get fired in response to an explicit setFont, setBackground, or SetForeground on the current component. Note that if the current component is inheriting its foreground, background, or font from its container, then no event will be fired in response to a change in the inherited property. If listener is null, no exception is thrown and no action is performed.

  Parameters:
    `listener` - The PropertyChangeListener to be added

### removePropertyChangeListener

    public void removePropertyChangeListener(PropertyChangeListener listener)

  Remove a PropertyChangeListener from the listener list. This removes a PropertyChangeListener that was registered for all properties. If listener is null, no exception is thrown and no action is performed.
  Parameters:
    `listener` - The PropertyChangeListener to be removed

### addPropertyChangeListener

    public void addPropertyChangeListener(String propertyName,
                                          PropertyChangeListener listener)

  Add a PropertyChangeListener for a specific property. The listener will be invoked only when a call on firePropertyChange names that specific property. If listener is null, no exception is thrown and no action is performed.
  Parameters:
    `propertyName` - The name of the property to listen on.
    `listener` - The PropertyChangeListener to be added

### removePropertyChangeListener

    public void removePropertyChangeListener(String propertyName,
                                             PropertyChangeListener listener)

  Remove a PropertyChangeListener for a specific property. If listener is null, no exception is thrown and no action is performed.
  Parameters:
    `propertyName` - The name of the property that was listened on.
    `listener` - The PropertyChangeListener to be removed

### firePropertyChange

    protected void firePropertyChange(String propertyName,
                                      Object oldValue,
                                      Object newValue)

  Support for reporting bound property changes. This method can be called when a bound property has changed and it will send the appropriate PropertyChangeEvent to any registered PropertyChangeListeners.

### setComponentOrientation

    public void setComponentOrientation(ComponentOrientation o)

  Set the language-sensitive orientation that is to be used to order the elements or text within this component. Language-sensitive LayoutManager and Component subclasses will use this property to determine how to lay out and draw components.

  At construction time, a component's orientation is set to ComponentOrientation.UNKNOWN, indicating that it has not been specified explicitly. The UNKNOWN orientation behaves the same as ComponentOrientation.LEFT_TO_RIGHT.

  To set the orientation of a single component, use this method. To apply a ResourceBundle's orientation to an entire component hierarchy, use java.awt.Window.applyResourceBundle.

  See Also:
    `ComponentOrientation`, `Window.applyResourceBundle(java.util.ResourceBundle)`

### getComponentOrientation

    public ComponentOrientation getComponentOrientation()

  Retrieve the language-sensitive orientation that is to be used to order the elements or text within this component. LayoutManager and Component subclasses that wish to respect orientation should call this method to get the component's orientation before performing layout or drawing.
  See Also:
    `ComponentOrientation`

### getAccessibleContext

    public AccessibleContext getAccessibleContext()

  Get the AccessibleContext associated with this Component
  Returns:
    the AccessibleContext of this Component

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| JavaTM 2 Platform Std. Ed. v1.3.1
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Submit a bug or feature
For further API reference and developer documentation, see Java 2 SDK SE Developer Documentation. That documentation contains more detailed, developer-targeted descriptions, with conceptual overviews, definitions of terms, workarounds, and working code examples.

Java, Java 2D, and JDBC are trademarks or registered trademarks of Sun Microsystems, Inc. in the US and other countries.
Copyright 1993-2001 Sun Microsystems, Inc. 901 San Antonio Road
Palo Alto, California, 94303, U.S.A. All Rights Reserved.